﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;

namespace _97824
{
    public partial class MyCombo : UserControl, INotifyPropertyChanged
    {

        [FlagsAttribute]
        public enum E { One = 1, Two = 2, Four = 4, Eight = 8 }


        public int Value
        {
            get { return ConvertComboVlaueToInt(); }
            set { this.ultraComboEditor1.Value = ConvertIntToE(value, this.ultraComboEditor1);
            }

        }

        public MyCombo()
        {
            InitializeComponent();
            foreach (E en in Enum.GetValues(typeof(E)))
                ultraComboEditor1.Items.Add(new Infragistics.Win.ValueListItem(en));
        }

        List<object> ConvertIntToE(int i, UltraComboEditor combo)
        {
            E es = (E)i;
            Notify("Value");
            return Enum.GetValues(typeof(E)).Cast<E>().Where(v => es.HasFlag(v)).Cast<object>().ToList<object>();
        }

        int ConvertComboVlaueToInt()
        {
            List<object> l = (List<object>)ultraComboEditor1.Value;
            if (l == null)
                return 0;
            int res = 0;
            foreach (object o in l)
                res += (int)o;
            Notify("Value");
            return res;
        }

        protected override void OnEnter(EventArgs e)
        {
            base.OnEnter(e);
            ultraComboEditor1.Focus();
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void Notify(string property)
        {
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(property));
        }

        #endregion
    }
}
